#define A 0xCF8
#define D 0xCFC
#define BAR0 0x10
#define VENDEV 0x0E63494FL

unsigned long outpd( unsigned port, unsigned long value )
{
    _DX = port;
    _EAX = value;
    __emit__( 0x66, 0xEF ); // OUT DX,EAX
    return value;
}   // outpd

unsigned long inpd( unsigned port )
{
    _DX = port;
    __emit__( 0x66, 0xED ); // IN EAX,DX
    return ( _EAX );
}   // inpd

unsigned long readPCIConfigRegister(unsigned long bdf) // takes a bus-device-function value
{
  outpd(A, bdf | 0x80000000L);
  return inpd(D);
}

unsigned far pascal _export getBaseAddressOfPCIeEZBLEND(void)
{
    unsigned long busdevfunc = 0;
    do{
        if (readPCIConfigRegister(busdevfunc) == VENDEV) // if our VENDEV
            return readPCIConfigRegister(busdevfunc + BAR0) & 0x0000FFFCL; // then return BAR0 value, masked to avoid I/O bit confusion
        busdevfunc += (1<<11); // otherwise, check the next possible device/bus/function
    }while (busdevfunc < (255L << 16L) ); // increment "device number", which will wrap to increment bus number as needed // OUR devices only have one function, so we don't have to increment function number, we just leave it "0"
    return -1;
}


